#import <Foundation/Foundation.h>
#import "FlightInfo.h"
#import "SalesEntry.h"
#import "Passport.h"

@interface SoldStock : NSObject

@property (nonatomic, assign) NSInteger stock_id;
@property (nonatomic, assign) NSInteger sales_entry_id;
@property (nonatomic, assign) NSInteger product_id;
@property (nonatomic, strong) NSString *sold_to_name;
@property (nonatomic, strong) NSString *gender;
@property (nonatomic, strong) NSMutableDictionary *desc;
@property (nonatomic, assign) BOOL vendor_checkin;
@property (nonatomic, strong) NSString *boarding_number;

@property (nonatomic, strong) NSString *cn;
@property (nonatomic, assign) NSInteger room_no;
@property (nonatomic, strong) NSString *barcode;
@property (nonatomic, strong) NSString *people_type;
@property (nonatomic, assign) NSInteger people_age;
@property (nonatomic, weak) SalesEntry *entry;
@property (nonatomic, strong) Passport *passport;
@property (nonatomic, strong) FlightInfo *flight_info;
@property (nonatomic, strong) NSString *service_date;

@property (nonatomic, strong) NSString *firstName;
@property (nonatomic, strong) NSString *lastName;
@property (nonatomic, strong, readonly) BusStop *departureStop;
@property (nonatomic, strong, readonly) BusStop *arrivalStop;
@property (nonatomic, strong, readonly) NSString *otherLongDescription;
@property (nonatomic, strong, readonly) NSString *otherShortDescription;
@property (nonatomic, strong, readonly) NSString *hotelDescription;
@property (nonatomic, strong, readonly) NSAttributedString *attributedConfirmationAndBoardingDescription;

// customer-list-page
@property (nonatomic, strong) NSString *scheduleName;
@property (nonatomic, assign) NSInteger blockStatus;
@property (nonatomic, strong) NSString *soldDate;
@property (nonatomic, strong) NSString *soldTime;
@property (nonatomic, assign) CGFloat soldValue;
@property (nonatomic, strong) NSString *customerHomePhone;
@property (nonatomic, strong) NSString *creditCardNumber;
@property (nonatomic, strong, readwrite) NSString *departure;
@property (nonatomic, strong, readwrite) NSString *arrival;
@property (nonatomic, strong, readwrite) NSString *departureDate;
@property (nonatomic, strong, readonly) NSString *blockStatusName;
@property (nonatomic, strong, readonly) UIColor *blockStatusColor;
@property (nonatomic, assign) NSInteger busOrTourComb;
// customer-list-page

@property (nonatomic, assign) BOOL hidden;
@property (nonatomic, assign) BOOL checked;

- (NSString *)genderConvertToMaleFormatter;

+ (NSArray *)filteredStocks:(NSArray *)stocks byBasedType:(NSString *)basedType;

@end
